## gf-core-724bf6729561254fa1f23a8ccf7fd35baf213fc5.tar.gz

=== Makefile ===
.PHONY: all build install doc clean gf html deb pkg bintar sdist

# This gets the numeric part of the version from the cabal file
VERSION=$(shell sed -ne "s/^version: *\([0-9.]*\).*/\1/p" gf.cabal)

all: build

dist/setup-config: gf.cabal Setup.hs WebSetup.hs
	cabal configure

build: dist/setup-config
	cabal build

install:
	cabal copy
	cabal register

doc:
	cabal haddock

clean:
	cabal clean
	bash bin/clean_html

gf:
	cabal build rgl-none
	strip dist/build/gf/gf

html::
	bash bin/update_html

# Make a debian package. First add a suitable entry with the correct GF version
# number to the top of debian/changelog.
# (Tested on Ubuntu 15.04. You need to install dpkg-dev & debhelper.)
deb:
	dpkg-buildpackage -b -uc

# Make an OS X Installer package
pkg:
	FMT=pkg bash bin/build-binary-dist.sh

# Make a binary tar distribution
bintar:
	bash bin/build-binary-dist.sh

#sdist:
#	cabal sdist

# Make a source tar.gz distribution using git to make sure that everything is included.
# We put the distribution in dist/ so it is removed on `make clean`
sdist:
	test -d dist || mkdir dist
	git archive --format=tar.gz --output=dist/gf-${VERSION}.tar.gz HEAD

=== doc/Makefile ===
gf-help-full.txt::
	{ echo ; echo ; echo ; } > $@
	echo help -full -t2t | gf -run >> $@

### Converting SVG logos to PNG, using convert from ImageMagick
logos:: Logos/gf00.png Logos/gf0.png

Logos/gf00.png: Logos/gf00.svg Makefile
	convert -background 'rgba(255,255,255,0)' -size 264x216 -depth 8 $< $@

Logos/gf0.png: Logos/gf0.svg Makefile
	convert -background 'rgba(255,255,255,0)' -size 320x240 -depth 8 $< $@

=== src/runtime/java/Makefile ===
INSTALL_PATH = /usr/local

C_SOURCES = jpgf.c jsg.c jni_utils.c
JAVA_SOURCES = $(wildcard org/grammaticalframework/pgf/*.java) \
               $(wildcard org/grammaticalframework/sg/*.java)

JNI_INCLUDES = $(if $(wildcard /usr/lib/jvm/default-java/include/.*), -I/usr/lib/jvm/default-java/include -I/usr/lib/jvm/default-java/include/linux, \
               $(if $(wildcard /usr/lib/jvm/java-1.11.0-openjdk-amd64/include/.*), -I/usr/lib/jvm/java-1.11.0-openjdk-amd64/include/ -I/usr/lib/jvm/java-1.11.0-openjdk-amd64/include/linux, \
               $(if $(wildcard /System/Library/Frameworks/JavaVM.framework/Versions/A/Headers/.*), -I/System/Library/Frameworks/JavaVM.framework/Versions/A/Headers, \
               $(if $(wildcard /Library/Java/Home/include/.*), -I/Library/Java/Home/include/ -I/Library/Java/Home/include/darwin, \
               $(error No JNI headers found)))))

# For compilation on Windows replace the previous line with something like this:
#
# JNI_INCLUDES  = -I "C:/Program Files/Java/jdk1.8.0_171/include" -I "C:/Program Files/Java/jdk1.8.0_171/include/win32" -I "C:/MinGW/msys/1.0/local/include"
# WINDOWS_LDFLAGS = -L"C:/MinGW/msys/1.0/local/lib" -no-undefined

GCC = gcc
LIBTOOL = $(if $(shell command -v glibtool 2>/dev/null), glibtool, libtool)  --tag=CC

# For cross-compilation from Linux to Windows replace the previous two lines with:
#
# GCC = x86_64-w64-mingw32-gcc
# LIBTOOL = ../c/libtool
# WINDOWS_CCFLAGS = -I$(INSTALL_PATH)/include
# WINDOWS_LDFLAGS = -L$(INSTALL_PATH)/lib -no-undefined

all: libjpgf.la jpgf.jar

libjpgf.la: $(patsubst %.c, %.lo, $(C_SOURCES))
	$(LIBTOOL) --mode=link $(GCC) $(CFLAGS) -g -O -o libjpgf.la -shared $^ -rpath $(INSTALL_PATH)/lib -lgu -lpgf -lsg $(WINDOWS_LDFLAGS)

%.lo : %.c
	$(LIBTOOL) --mode=compile $(GCC) $(CFLAGS) -g -O -c $(JNI_INCLUDES) $(WINDOWS_CCFLAGS) -std=c99 -shared $< -o $@

jpgf.jar: $(patsubst %.java, %.class, $(JAVA_SOURCES))
	jar -cf $@ org/grammaticalframework/pgf/*.class org/grammaticalframework/sg/*.class

%.class : %.java
	javac $<

install: libjpgf.la jpgf.jar
	$(LIBTOOL) --mode=install install -s libjpgf.la $(INSTALL_PATH)/lib
	install jpgf.jar $(INSTALL_PATH)/lib


doc:
	javadoc org.grammaticalframework.pgf org.grammaticalframework.sg -d java-api

clean:
	rm -f *.lo
	rm -f *.la
	rm -f -r .libs
	rm -f *.jar
	rm -f org/grammaticalframework/*/*.class

=== debian/changelog ===
gf (3.10.3-1) xenial bionic cosmic; urgency=low

  * GF 3.10.3

 -- Thomas Hallgren <hallgren@chalmers.se>  Fri,  5 Mar 2019 19:30:00 +0100

gf (3.10-2) xenial bionic cosmic; urgency=low

  * GF 3.10

 -- Thomas Hallgren <hallgren@chalmers.se>  Fri,  5 Mar 2019 16:00:00 +0100

gf (3.10-1) xenial bionic cosmic; urgency=low

  * GF 3.10

 -- Thomas Hallgren <hallgren@chalmers.se>  Fri,  2 Dec 2018 15:00:00 +0100

gf (3.9-1) vivid xenial zesty; urgency=low

  * GF 3.9

 -- Thomas Hallgren <hallgren@chalmers.se>  Fri, 11 Aug 2017 20:00:00 +0200

gf (3.8-1) precise trusty vivid; urgency=low

  * GF 3.8

 -- Thomas Hallgren <hallgren@chalmers.se>  Wed, 22 Jun 2016 14:00:00 +0200

gf (3.7.1-1) precise trusty vivid; urgency=low

  * GF 3.7.1

 -- Thomas Hallgren <hallgren@chalmers.se>  Fri,  2 Oct 2015 14:00:00 +0200

gf (3.7-1) precise trusty vivid; urgency=low

  * GF 3.7

 -- Thomas Hallgren <hallgren@chalmers.se>  Tue,  25 Jun 2015 14:00:00 +0200

gf (3.6-1) precise saucy trusty; urgency=low

  * GF 3.6

 -- Thomas Hallgren <hallgren@chalmers.se>  Tue,  21 Jun 2014 20:00:00 +0200

gf (3.5-1) precise quantal; urgency=low

  * GF 3.5

 -- Thomas Hallgren <hallgren@chalmers.se>  Tue,  6 Aug 2013 17:30:00 +0200

gf (3.4-1) precise quantal; urgency=low

  * GF 3.4

 -- Thomas Hallgren <hallgren@chalmers.se>  Wed,  31 Dec 2012 00:00:00 +0200

gf (3.3.11-1) oneiric precise quantal; urgency=low

  * GF 3.3.11

 -- Thomas Hallgren <hallgren@chalmers.se>  Wed,  7 Dec 2012 16:50:00 +0200

gf (3.3.3-1) oneiric precise; urgency=low

  * GF 3.3.3

 -- Thomas Hallgren <hallgren@chalmers.se>  Wed, 22 Aug 2012 16:50:00 +0200

gf (3.3-1) natty; urgency=low

  * GF 3.3.

 -- Thomas Hallgren <th0907@altocumulus.org>  Wed, 26 Oct 2011 22:10:42 +0200

gf (2.5-1) unstable; urgency=low

  * Initial packaging.

 -- Bjorn Bringert <bringert@cs.chalmers.se>  Tue, 21 Mar 2006 11:12:25 +0100

=== debian/control ===
Source: gf
Section: devel
Priority: optional
Maintainer: Thomas Hallgren <hallgren@chalmers.se>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 5), haskell-platform (>= 2011.2.0.1), libghc-haskeline-dev, libghc-mtl-dev, libghc-json-dev, autoconf, automake, libtool-bin, python-dev, java-sdk, txt2tags, pandoc
Homepage: http://www.grammaticalframework.org/

Package: gf
Architecture: any
Depends: ${shlibs:Depends}
Description: Tools for GF, a grammar formalism based on type theory
 Grammatical Framework (GF) is a grammar formalism based on type theory. 
 It consists of a special-purpose programming language,
 a compiler of the language, and a generic grammar processor.
 .

=== debian/rules ===
#!/usr/bin/make -f

%: 
	+dh $@

#dh_shlibdeps has a problem finding which package some of the Haskell
#libraries come from, even though dpkg-query -S has no problem finding them.
#But the gf executable is statically linked against the Haskell libraries, so
#it will work even if these shared libraries aren't installed. But there will
#be a problem if other shared libraries are missing (.e.g. libtinfo, libgmp),
#so we need a better solution than simply ignoring all dependency problems...
#See also http://stackoverflow.com/questions/11238134/dpkg-shlibdeps-error-no-dependency-information-found-for
override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_configure:
	cd src/runtime/c && bash setup.sh configure --prefix=/usr
	cd src/runtime/c && bash setup.sh build
	cabal update
	cabal install --only-dependencies
	cabal configure --prefix=/usr -fserver -fc-runtime --extra-lib-dirs=$(CURDIR)/src/runtime/c/.libs --extra-include-dirs=$(CURDIR)/src/runtime/c

SET_LDL=LD_LIBRARY_PATH=$$LD_LIBRARY_PATH:$(CURDIR)/src/runtime/c/.libs

override_dh_auto_build:
	cd src/runtime/python && EXTRA_INCLUDE_DIRS=$(CURDIR)/src/runtime/c EXTRA_LIB_DIRS=$(CURDIR)/src/runtime/c/.libs python setup.py build
	cd src/runtime/java && make CFLAGS="-I$(CURDIR)/src/runtime/c -L$(CURDIR)/src/runtime/c/.libs" INSTALL_PATH=/usr/lib
	echo $(SET_LDL)
	-$(SET_LDL) cabal build # builds gf, fails to build example grammars
	export $(SET_LDL); PATH=$(CURDIR)/dist/build/gf:$$PATH && make -C ../gf-rgl build
	GF_LIB_PATH=$(CURDIR)/../gf-rgl/dist $(SET_LDL) cabal build # have RGL now, ok to build example grammars
	make html

override_dh_auto_install:
	$(SET_LDL) cabal copy --destdir=$(CURDIR)/debian/gf # creates www directory
	export GF_LIB_PATH="$$(dirname $$(find "$(CURDIR)/debian/gf" -name www))/lib" && echo "GF_LIB_PATH=$$GF_LIB_PATH" && mkdir -p "$$GF_LIB_PATH" && make -C ../gf-rgl copy
	cd src/runtime/c && bash setup.sh copy prefix=$(CURDIR)/debian/gf/usr
	cd src/runtime/python && python setup.py install --prefix=$(CURDIR)/debian/gf/usr
	cd src/runtime/java && make INSTALL_PATH=$(CURDIR)/debian/gf/usr/lib install
	D="`find debian/gf -name site-packages`" && [ -n "$$D" ] && cd $$D && cd .. && mv site-packages dist-packages

override_dh_auto_clean:
	rm -fr dist/build
	-cd src/runtime/python && rm -fr build
	-cd src/runtime/java && make clean
	-cd src/runtime/c && make clean

override_dh_auto_test:
ifneq (nocheck,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	true
#	cabal test
endif
